#!/usr/bin/php
<?php

include_once "/opt/monitor/op5/gui/db_utils.inc.php";
include_once "smsacknowledge.inc.php";
include_once "/opt/monitor/op5/smsreceive/smsreceiver/utils.php";


if($argc<2){ 
	printLog("Wrong number of arguments, aborting");
	exit(1);
}

printLog("Ack sms '$argv[1]'");
$incommingmessage=processSmsMessage($argv[1]);

smsack($incommingmessage);

deletefile($argv[1]);

function smsack($smsmessage){
    GLOBAL $sticky, $notify, $persistent, $hostAckString, $serviceAckString;
    GLOBAL $smsDelimiter, $smsDynamicDelimiter, $commandfile;
    
    
    $res = gui_db_connect();
    $tmp = sql_exec_query("SELECT contact_name FROM contact WHERE pager='" . 
			  $smsmessage['from'] . "'" );
    
    $author = "";
    if($row = sql_fetch_array($tmp)){
	$author = $row['contact_name'];
    } else {
	printLog("No contact matching pager, exiting");
	return;
    }
    $tmp = sql_exec_query("SELECT host_name FROM host");
    if(!$hosts = sql_fetch_result($tmp)){
	printLog("No hosts found, exiting");
	return;
    }
    # var_dump($hosts);
    gui_db_close();
    
    $smsArr = explode($smsDelimiter, $smsmessage['content']);
    $commandString = "";
    
    # First, look for manually witten  acknowledge messages
    if(strcasecmp($smsArr[0], $hostAckString) === 0){
	printLog("Host ack");
	$commandString = "ACKNOWLEDGE_HOST_PROBLEM;" . $smsArr[1] . ";";
	$commandString .=  $sticky . ";" . $notify . ";" . $persistent . ";"; 
	$commandString .=  $author . ";" . $smsArr[2];
    } else if(strcasecmp($smsArr[0], $serviceAckString) === 0){
	printLog("Service ack");
	$commandString = "ACKNOWLEDGE_SVC_PROBLEM;" . $smsArr[1] . ";"; 
	$commandString .=  $smsArr[2] . ";" . $sticky . ";" . $notify . ";" . $persistent;
	$commandString .=  ";" . $author . ";" . $smsArr[3];
    } else {
	# Fall back, try to match on sms-reply
	$tmpStr = strtok($smsmessage['content'], $smsDynamicDelimiter);
	$tmpArr = explode(" ",$tmpStr);
	$c = count($tmpArr);
	$index=0;
	$hostName = "";
	$serviceDescr = "";
	# Try to match on service ack
	foreach($hosts as $host){
	    if(stristr($tmpStr, " on " . $host["host_name"] . " ")){ 
		printLog("Fallback, service ack");		
		#		    printf( "host " . $host["host_name"] . " \n"); 
		$tmpArr2 = explode( " on " . $host["host_name"] . " ", $tmpStr);
		#		    printf( "service '" . $tmpArr2[0] . "' \n"); 
		#		    print("$tmpStr");
		$serviceDescr = $tmpArr2[0];
		$hostName = $host["host_name"];
		$commandString = "ACKNOWLEDGE_SVC_PROBLEM;" . $hostName . ";";
		$commandString .=  $serviceDescr . ";" . $sticky . ";" . $notify . ";" . $persistent . ";";
		$commandString .=  $author . ";SMS acknowledgement";
	    }
	    
	}
	# Final fallback, interpret message as host ack
	if($hostName == ""){
	    printLog("Fallback, host ack");		
	    $commandString = "ACKNOWLEDGE_HOST_PROBLEM;" . $tmpArr[0] . ";" ;
	    $commandString .=  $sticky . ";" . $notify . ";" . $persistent . ";" . $author;
	    $commandString .=   ";SMS acknowledgement";
	}

    }
#    print("cmdStr: $commandString\n");
#    exit(0);		  
    printLog("About to write: '$commandString' to commandfile");
    #	echo "time: " . time() . "\n";
    #	echo "command: $commandString \n";
    
    $fHandle = fopen($commandfile, "a");
    if(!$fHandle){
	printLog("Failed to open file '$commandfile' for writing, Aborting.");
	return;
    }
    $ret = fwrite($fHandle, "[". time() . "] " . $commandString);
    if(!$ret){
	printLog("Failed to write file '$commandfile'");
    }
    fclose($fHandle);
}



?>
